const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function (sequelize, DataTypes) {
  const inspecao_aerea = sequelize.define(
    'inspecao_aerea',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

      data_inspecao: {
        type: DataTypes.DATE,
      },

      tipo_inspecao: {
        type: DataTypes.TEXT,
      },

      observacoes: {
        type: DataTypes.TEXT,
      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  inspecao_aerea.associate = (db) => {
    /// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity

    db.inspecao_aerea.hasMany(db.frames_imagem, {
      as: 'frames_imagem_inspecao',
      foreignKey: {
        name: 'inspecaoId',
      },
      constraints: false,
    });

    db.inspecao_aerea.hasMany(db.gemeos_digitais, {
      as: 'gemeos_digitais_inspecao',
      foreignKey: {
        name: 'inspecaoId',
      },
      constraints: false,
    });

    db.inspecao_aerea.hasMany(db.relatorios_analiticos_video, {
      as: 'relatorios_analiticos_video_inspecao',
      foreignKey: {
        name: 'inspecaoId',
      },
      constraints: false,
    });

    //end loop

    db.inspecao_aerea.belongsTo(db.obras, {
      as: 'obra',
      foreignKey: {
        name: 'obraId',
      },
      constraints: false,
    });

    db.inspecao_aerea.belongsTo(db.clientes, {
      as: 'clientes',
      foreignKey: {
        name: 'clientesId',
      },
      constraints: false,
    });

    db.inspecao_aerea.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.inspecao_aerea.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };

  return inspecao_aerea;
};
